<p-toast></p-toast>
<p-confirmDialog header="Immediate session confirmation" icon="pi pi-exclamation-triangle"></p-confirmDialog>

<div class="row tutor-search-criteria">
  <div class="col">
    <label class="criterion-label" translate>Subject<span class="mandatory-asterisk">*</span></label>
    <p-dropdown styleClass="criterion-input"
                [options]="subjects"
                [(ngModel)]="tutorFilter.filter.subject"
    ></p-dropdown>
  </div>
  <div class="col">
    <label class="criterion-label" translate>Level<span class="mandatory-asterisk">*</span></label>
    <p-dropdown styleClass="criterion-input"
                [options]="levels"
                [(ngModel)]="tutorFilter.filter.level"
    ></p-dropdown>
  </div>
  <div class="col">
    <label class="criterion-label" translate>Price</label>
    <div class="price-range-input">
      <p-slider styleClass="criterion-input"
                [min]="minPrice"
                [max]="maxPrice"
                [(ngModel)]="tutorFilter.filter.price_range"
                [range]="true"
      ></p-slider>
      <div class="price-range-text">
        from {{tutorFilter.filter.price_range[0]}} to {{tutorFilter.filter.price_range[1]}} CHF/h
      </div>
    </div>
  </div>
  <div class="col">
    <label class="criterion-label" translate>Availability</label>
    <p-button styleClass="ui-button-rounded ui-button-secondary criterion-input"
              class="criterion-input"
              [label]="availabilityTextItems.join(', ')"
              (onClick)="availabilityPanel.toggle($event)"
    ></p-button>
  </div>
  <div class="col">
    <button pButton
            type="button"
            label="{{'Search'|translate}}"
            class="search-button ui-button ui-button-success"
            pTooltip="{{'Please select a subject and a level'|translate}}"
            tooltipPosition="bottom"
            disabled
            *ngIf="!tutorFilter.filter.subject || !tutorFilter.filter.level"
    ></button>
    <button pButton
            type="button"
            label="{{'Search'|translate}}"
            class="search-button ui-button ui-button-success"
            (click)="loadTutors()"
            *ngIf="tutorFilter.filter.subject && tutorFilter.filter.level"
    ></button>
  </div>
</div>

<p-overlayPanel #availabilityPanel class="availability-criteria" styleClass="p-1">
  <div class="row mb-1">
    <div class="col px-1">
      <p-toggleButton onLabel="{{'Immediate'|translate}}"
                      offLabel="{{'Immediate'|translate}}"
                      class="criterion-input" styleClass="criterion-input"
                      [(ngModel)]="availabilityImmediate"
                      (onChange)="refreshAvailabilityFilter(true)"></p-toggleButton>
    </div>
  </div>
  <div class="row mb-1">
    <div class="col pr-0 pl-1">
      <p-toggleButton onLabel="{{'Morning'|translate}}"
                      offLabel="{{'Morning'|translate}}"
                      class="criterion-input" styleClass="criterion-input"
                      [(ngModel)]="availabilityMorning"
                      (onChange)="refreshAvailabilityFilter()"></p-toggleButton>
    </div>
    <div class="col px-1">
      <p-toggleButton onLabel="{{'Afternoon'|translate}}"
                      offLabel="{{'Afternoon'|translate}}"
                      class="criterion-input" styleClass="criterion-input"
                      [(ngModel)]="availabilityAfternoon"
                      (onChange)="refreshAvailabilityFilter()"></p-toggleButton>
    </div>
    <div class="col pl-0 pr-1">
      <p-toggleButton onLabel="{{'Evening'|translate}}"
                      offLabel="{{'Evening'|translate}}"
                      class="criterion-input" styleClass="criterion-input"
                      [(ngModel)]="availabilityEvening"
                      (onChange)="refreshAvailabilityFilter()"></p-toggleButton>
    </div>
  </div>
  <div class="row">
    <div class="col pr-0 pl-1">
      <p-toggleButton onLabel="{{'MONDAY_SHORT'|translate}}"
                      offLabel="{{'MONDAY_SHORT'|translate}}"
                      class="criterion-input" styleClass="criterion-input"
                      [(ngModel)]="availabilityMonday"
                      (onChange)="refreshAvailabilityFilter()"></p-toggleButton>
    </div>
    <div class="col px-1">
      <p-toggleButton onLabel="{{'TUESDAY_SHORT'|translate}}"
                      offLabel="{{'TUESDAY_SHORT'|translate}}"
                      class="criterion-input" styleClass="criterion-input"
                      [(ngModel)]="availabilityTuesday"
                      (onChange)="refreshAvailabilityFilter()"></p-toggleButton>
    </div>
    <div class="col px-0">
      <p-toggleButton onLabel="{{'WEDNESDAY_SHORT'|translate}}"
                      offLabel="{{'WEDNESDAY_SHORT'|translate}}"
                      class="criterion-input" styleClass="criterion-input"
                      [(ngModel)]="availabilityWednesday"
                      (onChange)="refreshAvailabilityFilter()"></p-toggleButton>
    </div>
    <div class="col px-1">
      <p-toggleButton onLabel="{{'THURSDAY_SHORT'|translate}}"
                      offLabel="{{'THURSDAY_SHORT'|translate}}"
                      class="criterion-input" styleClass="criterion-input"
                      [(ngModel)]="availabilityThursday"
                      (onChange)="refreshAvailabilityFilter()"></p-toggleButton>
    </div>
    <div class="col px-0">
      <p-toggleButton onLabel="{{'FRIDAY_SHORT'|translate}}"
                      offLabel="{{'FRIDAY_SHORT'|translate}}"
                      class="criterion-input" styleClass="criterion-input"
                      [(ngModel)]="availabilityFriday"
                      (onChange)="refreshAvailabilityFilter()"></p-toggleButton>
    </div>
    <div class="col px-1">
      <p-toggleButton onLabel="{{'SATURDAY_SHORT'|translate}}"
                      offLabel="{{'SATURDAY_SHORT'|translate}}"
                      class="criterion-input" styleClass="criterion-input"
                      [(ngModel)]="availabilitySaturday"
                      (onChange)="refreshAvailabilityFilter()"></p-toggleButton>
    </div>
    <div class="col pl-0 pr-1">
      <p-toggleButton onLabel="{{'SUNDAY_SHORT'|translate}}"
                      offLabel="{{'SUNDAY_SHORT'|translate}}"
                      class="criterion-input" styleClass="criterion-input"
                      [(ngModel)]="availabilitySunday"
                      (onChange)="refreshAvailabilityFilter()"></p-toggleButton>
    </div>
  </div>
</p-overlayPanel>

<p-panel *ngFor="let tutor of tutors" styleClass="tutor-panel">
  <p-header>
    <div class="ui-helper-clearfix">
      <img src="api/users/{{tutor.id}}/photo"
           alt="{{'Profile picture of'|translate}} {{tutor.firstName}} {{tutor.lastName}}"
           width="60" height="60"
           class="mr-2 mt-0 mb-0 photo"
           style="float:left;"/>
      <div class="tutor-stars mt-1">
        <span *ngFor="let star of tutor.stars">
          <i class="pi pi-star" *ngIf="star == true"></i>
          <i class="pi pi-star pi-invert" *ngIf="star == false"></i>
        </span>
      </div>
      <span class="tutor-name">
        {{tutor.firstName}} {{tutor.lastName}}
        <span *ngFor="let language of tutor.languages"
              class="badge badge-dark">
          {{language|translate}}
        </span>
      </span>
      <span class="reserve-buttons">
        <button pButton
                type="button"
                class="request-now-button mr-1"
                label="{{'Request session now'|translate}}"
                (click)="requestImmediateSession(tutor)"
                *ngIf="tutor.availableNow"
        ></button>
        <button pButton
                type="button"
                class="reserve-button"
                label="{{'Reserve'|translate}}"
                (click)="reserve(tutor)"
        ></button>
      </span>
    </div>
  </p-header>
  <div>
    <h6 class="mt-0">
      <span *ngFor="let tutorClass of tutor.classes"availabilityMonday
            class="badge"
            [ngClass]="{
              'badge-light': !tutorClassMatchesTutorFilter(tutorClass),
              'badge-primary': tutorClassMatchesTutorFilter(tutorClass)
            }">
        {{tutorClass.subject|translate}}
        {{tutorClass.levels ? tutorClass.levels.join(', ') : ''}} :
        {{tutorClass.price|currency:'CHF '}}
      </span>
    </h6>
    <p>
      {{tutor.description}}
    </p>
  </div>
</p-panel>

<div *ngIf="noTutorFound">
  <br>
  <ngb-alert type="warning"
             [dismissible]="false"
             translate
  >No tutor found for the selected criteria.</ngb-alert>
</div>



